#include <wchar.h>
#include <Python.h>

int main(int argc, char **argv)
{
#if PY_MAJOR_VERSION >= 3
    extern PyObject *PyInit_sip(void);
    extern PyObject *PyInit_QtGui(void);
    extern PyObject *PyInit_QtWidgets(void);
    extern PyObject *PyInit_QtCore(void);

    static struct _inittab extension_modules[] = {
        {"sip", PyInit_sip},
        {"PyQt5.QtGui", PyInit_QtGui},
        {"PyQt5.QtWidgets", PyInit_QtWidgets},
        {"PyQt5.QtCore", PyInit_QtCore},
        {NULL, NULL}
    };
#else
    extern void initsip(void);
    extern void initQtGui(void);
    extern void initQtWidgets(void);
    extern void initQtCore(void);

    static struct _inittab extension_modules[] = {
        {"sip", initsip},
        {"PyQt5.QtGui", initQtGui},
        {"PyQt5.QtWidgets", initQtWidgets},
        {"PyQt5.QtCore", initQtCore},
        {NULL, NULL}
    };
#endif

#if PY_MAJOR_VERSION >= 3
    extern int pyqtdeploy_main(int argc, char **argv, wchar_t *py_main,
            struct _inittab *extension_modules);

    return pyqtdeploy_main(argc, argv, L"wiggly", extension_modules);
#else
    extern int pyqtdeploy_main(int argc, char **argv, char *py_main,
            struct _inittab *extension_modules);

    return pyqtdeploy_main(argc, argv, "wiggly", extension_modules);
#endif
}
